<template>
  <form
    id="search-anchor"
    class="mx-auto flex flex-wrap gap-2 text-center items-center justify-center dark:text-slate-100 pb-2"
    role="search"
    @submit.prevent="doNewSearch"
  >
    <div class="flex-auto max-w-lg relative">
      <label for="searchMainField" class="sr-only">
        {{ $gettext('Your search') }}</label
      >
      <div
        class="flex absolute inset-y-0 left-0 items-center pl-3 pointer-events-none"
      >
        <svg
          aria-hidden="true"
          width="24"
          height="24"
          stroke-width="1.5"
          viewBox="0 0 24 24"
          fill="none"
          xmlns="http://www.w3.org/2000/svg"
        >
          <path
            d="M15.5 15.5L19 19"
            stroke="currentColor"
            stroke-linecap="round"
            stroke-linejoin="round"
          />
          <path
            d="M5 11C5 14.3137 7.68629 17 11 17C12.6597 17 14.1621 16.3261 15.2483 15.237C16.3308 14.1517 17 12.654 17 11C17 7.68629 14.3137 5 11 5C7.68629 5 5 7.68629 5 11Z"
            stroke="currentColor"
            stroke-linecap="round"
            stroke-linejoin="round"
          />
        </svg>
      </div>
      <input
        id="searchMainField"
        v-model="search"
        @change="searchChange"
        :placeholder="$gettext('Keyword, event title, group name, etc.')"
        autofocus
        type="text"
        name="search"
        autocapitalize="off"
        autocomplete="off"
        autocorrect="off"
        maxlength="1024"
        class="dark:bg-zinc-900 min-w-max md:max-w-lg bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg focus:ring-blue-500 focus:border-blue-500 block w-full pl-10 p-2.5 dark:bg-gray-700 dark:border-gray-600 dark:placeholder-gray-400 dark:text-white dark:focus:ring-blue-500 dark:focus:border-blue-500"
      />
    </div>

    <location-autocomplete
      :search="findLocation"
      v-model="locationString"
      @submit="
        (location) =>
          $emit('update:location', {
            lon: location.location.lon,
            lat: location.location.lat,
            name: location.name,
          })
      "
      :placeholder="$gettext('Location')"
      :getResultValue="(result) => result.name"
    />

    <button
      class="inline-flex bg-primary text-white px-4 py-2 justify-center flex-auto md:max-w-fit"
      type="submit"
    >
      <svg
        aria-hidden="true"
        xmlns="http://www.w3.org/2000/svg"
        width="24"
        height="24"
        viewBox="0 0 24 24"
        fill="none"
        stroke="currentColor"
        stroke-width="2"
        stroke-linecap="round"
        stroke-linejoin="round"
      >
        <circle cx="11" cy="11" r="8"></circle>
        <line x1="21" y1="21" x2="16.65" y2="16.65"></line>
      </svg>

      <translate v-if="search">Go!</translate>
      <translate v-else>Explore!</translate>
    </button>
  </form>
</template>

<script setup lang="ts">
  import { searchLocations } from '@/shared/search'
  import { ref, computed } from 'vue'
  import { AutoCompleteLocation } from '../../../../server/types/address.model'
  import { LocationType } from '../../../../shared/user-location.model'
  import LocationAutocomplete from './LocationAutocomplete.vue'

  const search = ref('')
  const locationName = ref<string>(undefined)

  const props = defineProps<{
    location: LocationType
    search: string
  }>()

  const locationString = computed<string>({
    get() {
      return locationName.value ?? props.location.name
    },
    set(newValue) {
      locationName.value = newValue
      if (newValue === '') {
        emit('update:location', { lon: '', lat: '', name: '' })
      }
    },
  })

  const emit = defineEmits<{
    (e: 'update:location', location: LocationType): void
    (e: 'update:search', search: string): void
    (e: 'submit')
  }>()

  async function findLocation(
    location: string
  ): Promise<AutoCompleteLocation[]> {
    if (location === '') return Promise.resolve([])
    return (await searchLocations(location))?.data
  }

  function doNewSearch(): void {
    emit('submit')
  }

  function searchChange(e: Event): void {
    emit('update:search', (e.target as HTMLInputElement).value)
  }
</script>
